####################################################################################

set_property -dict {PACKAGE_PIN D18 IOSTANDARD LVCMOS33} [get_ports OSC_CLK]
create_clock -period 20.000 -name OSC_CLK -waveform {0.000 10.000} [get_ports OSC_CLK]

####################################################################################

set_property -dict {PACKAGE_PIN M4 IOSTANDARD LVCMOS33} [get_ports {PB[0]}]
set_property -dict {PACKAGE_PIN L4 IOSTANDARD LVCMOS33} [get_ports {PB[1]}]
set_property -dict {PACKAGE_PIN L5 IOSTANDARD LVCMOS33} [get_ports {PB[2]}]
set_property -dict {PACKAGE_PIN K5 IOSTANDARD LVCMOS33} [get_ports {PB[3]}]

#set_property -dict {PACKAGE_PIN R1 IOSTANDARD LVCMOS33} [get_ports PB_PROG]
set_property -dict {PACKAGE_PIN R1 IOSTANDARD LVCMOS33} [get_ports {PB[4]}]

set_property -dict {PACKAGE_PIN P1 IOSTANDARD LVCMOS33} [get_ports {PB[5]}]
set_property -dict {PACKAGE_PIN R7 IOSTANDARD LVCMOS33} [get_ports {PB[6]}]
#set_property -dict {PACKAGE_PIN R7 IOSTANDARD LVCMOS33} [get_ports EXT_RSTN]


set_property -dict {PACKAGE_PIN R21 IOSTANDARD LVCMOS33} [get_ports I2C_SDA]
set_property -dict {PACKAGE_PIN R20 IOSTANDARD LVCMOS33} [get_ports I2C_SCL]

set_property -dict {PACKAGE_PIN C19 IOSTANDARD LVCMOS33} [get_ports ADDA_I2C_SDA]
set_property -dict {PACKAGE_PIN E20 IOSTANDARD LVCMOS33} [get_ports ADDA_I2C_SCL]



set_property -dict {PACKAGE_PIN N8 IOSTANDARD LVCMOS33} [get_ports {SW[0]}]
set_property -dict {PACKAGE_PIN M5 IOSTANDARD LVCMOS33} [get_ports {SW[1]}]
set_property -dict {PACKAGE_PIN P4 IOSTANDARD LVCMOS33} [get_ports {SW[2]}]
set_property -dict {PACKAGE_PIN N4 IOSTANDARD LVCMOS33} [get_ports {SW[3]}]
set_property -dict {PACKAGE_PIN U6 IOSTANDARD LVCMOS33} [get_ports {SW[4]}]
set_property -dict {PACKAGE_PIN U5 IOSTANDARD LVCMOS33} [get_ports {SW[5]}]
set_property -dict {PACKAGE_PIN R8 IOSTANDARD LVCMOS33} [get_ports {SW[6]}]
set_property -dict {PACKAGE_PIN P8 IOSTANDARD LVCMOS33} [get_ports {SW[7]}]


set_property -dict {PACKAGE_PIN K26 IOSTANDARD LVCMOS33} [get_ports {SEG[0]}]
set_property -dict {PACKAGE_PIN M20 IOSTANDARD LVCMOS33} [get_ports {SEG[1]}]
set_property -dict {PACKAGE_PIN L20 IOSTANDARD LVCMOS33} [get_ports {SEG[2]}]
set_property -dict {PACKAGE_PIN N21 IOSTANDARD LVCMOS33} [get_ports {SEG[3]}]
set_property -dict {PACKAGE_PIN N22 IOSTANDARD LVCMOS33} [get_ports {SEG[4]}]
set_property -dict {PACKAGE_PIN T24 IOSTANDARD LVCMOS33} [get_ports {SEG[5]}]
set_property -dict {PACKAGE_PIN P23 IOSTANDARD LVCMOS33} [get_ports {SEG[6]}]
set_property -dict {PACKAGE_PIN P24 IOSTANDARD LVCMOS33} [get_ports {SEG[7]}]

set_property -dict {PACKAGE_PIN R16 IOSTANDARD LVCMOS33} [get_ports {SEAT[5]}]
set_property -dict {PACKAGE_PIN R17 IOSTANDARD LVCMOS33} [get_ports {SEAT[4]}]
set_property -dict {PACKAGE_PIN N18 IOSTANDARD LVCMOS33} [get_ports {SEAT[3]}]
set_property -dict {PACKAGE_PIN K25 IOSTANDARD LVCMOS33} [get_ports {SEAT[2]}]
set_property -dict {PACKAGE_PIN R25 IOSTANDARD LVCMOS33} [get_ports {SEAT[1]}]
set_property -dict {PACKAGE_PIN P21 IOSTANDARD LVCMOS33} [get_ports {SEAT[0]}]


set_property -dict {PACKAGE_PIN N17 IOSTANDARD LVCMOS33} [get_ports {LED[0]}]
set_property -dict {PACKAGE_PIN M19 IOSTANDARD LVCMOS33} [get_ports {LED[1]}]
set_property -dict {PACKAGE_PIN P16 IOSTANDARD LVCMOS33} [get_ports {LED[2]}]
set_property -dict {PACKAGE_PIN N16 IOSTANDARD LVCMOS33} [get_ports {LED[3]}]
set_property -dict {PACKAGE_PIN N19 IOSTANDARD LVCMOS33} [get_ports {LED[4]}]
set_property -dict {PACKAGE_PIN P19 IOSTANDARD LVCMOS33} [get_ports {LED[5]}]
set_property -dict {PACKAGE_PIN N24 IOSTANDARD LVCMOS33} [get_ports {LED[6]}]
set_property -dict {PACKAGE_PIN N23 IOSTANDARD LVCMOS33} [get_ports {LED[7]}]

####################################################################################
##Quad SPI Flash FPGA & RISCV CODE

set_property -dict {PACKAGE_PIN M22 IOSTANDARD LVCMOS33 IOB TRUE} [get_ports QSPI_SCK]
create_clock -period 20.000 -name QSPI_SCK -waveform {0.000 10.000} -add [get_nets QSPI_SCK]



#fcs_b
set_property -dict {PACKAGE_PIN P18 IOSTANDARD LVCMOS33} [get_ports QSPI_CS]

#sdi
set_property PACKAGE_PIN R14 [get_ports {QSPI_DQ[0]}]
set_property IOSTANDARD LVCMOS33 [get_ports {QSPI_DQ[0]}]
set_property PULLUP true [get_ports {QSPI_DQ[0]}]
set_property IOB TRUE [get_ports {QSPI_DQ[0]}]

#sdo
set_property PACKAGE_PIN R15 [get_ports {QSPI_DQ[1]}]
set_property IOSTANDARD LVCMOS33 [get_ports {QSPI_DQ[1]}]
set_property PULLUP true [get_ports {QSPI_DQ[1]}]
set_property IOB TRUE [get_ports {QSPI_DQ[1]}]

#wp
set_property PACKAGE_PIN P14 [get_ports {QSPI_DQ[2]}]
set_property IOSTANDARD LVCMOS33 [get_ports {QSPI_DQ[2]}]
set_property PULLUP true [get_ports {QSPI_DQ[2]}]
set_property IOB TRUE [get_ports {QSPI_DQ[2]}]

#hold
set_property PACKAGE_PIN N14 [get_ports {QSPI_DQ[3]}]
set_property IOSTANDARD LVCMOS33 [get_ports {QSPI_DQ[3]}]
set_property PULLUP true [get_ports {QSPI_DQ[3]}]
set_property IOB TRUE [get_ports {QSPI_DQ[3]}]


set_property -dict {PACKAGE_PIN L18 IOSTANDARD LVCMOS33} [get_ports UART_TXD]
set_property -dict {PACKAGE_PIN L17 IOSTANDARD LVCMOS33} [get_ports UART_RXD]

####################################################################################


set_clock_groups -name CG_sysclk -asynchronous -group [get_clocks [get_clocks -of_objects [get_pins HL_clk_inst/inst/mmcm_adv_inst/CLKOUT1]]]
set_clock_groups -name CG_l_clk -asynchronous -group [get_clocks [get_clocks -of_objects [get_pins HL_clk_inst/inst/mmcm_adv_inst/CLKOUT0]]]


####################################################################################
#SPI to FMC

set_property BITSTREAM.CONFIG.M0PIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.M1PIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.M2PIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.TCKPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.TDIPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.TDOPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.TMSPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.UNUSEDPIN PULLNONE [current_design]


set_property BITSTREAM.CONFIG.SPI_BUSWIDTH 4 [current_design]
#set_property CONFIG_MODE SPIx1 [current_design]

set_property BITSTREAM.CONFIG.INITSIGNALSERROR DISABLE [current_design]


set_property CONFIG_VOLTAGE 3.3 [current_design]
set_property CFGBVS VCCO [current_design]
set_property BITSTREAM.CONFIG.CCLKPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.DONEPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.INITPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.PROGPIN PULLNONE [current_design]
set_property BITSTREAM.CONFIG.DCIUPDATEMODE QUIET [current_design]
set_property BITSTREAM.CONFIG.USR_ACCESS TIMESTAMP [current_design]
####################################################################################






















