`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Modified Date: 2020-02-28
// Design Name:
// Module Name: csr_misa
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module csr_misa
(
   input       [11:0]  i_csr_addr,
   output      [31:0]  o_misa
);

assign o_misa = {
    2'b1 //      32 bit       
   ,4'b0 //      WIRI
   ,1'b0 //      25 Z Reserved
   ,1'b0 //      24 Y Reserved
   ,1'b0 //      23 X Non-standard extensions present
   ,1'b0 //      22 W Reserved
   ,1'b0 //      21 V Tentatively reserved for Vector extension 20 U User mode implemented
   ,1'b0 //      20 U User mode implemented
   ,1'b0 //      19 T Tentatively reserved for Transactional Memory extension
   ,1'b0 //      18 S Supervisor mode implemented
   ,1'b0 //      17 R Reserved
   ,1'b0 //      16 Q Quad-precision floating-point extension
   ,1'b0 //      15 P Tentatively reserved for Packed-SIMD extension
   ,1'b0 //      14 O Reserved
   ,1'b0 //      13 N User-level interrupts supported
   ,1'b0 //      12 M Integer Multiply/Divide extension
   ,1'b0 //      11 L Tentatively reserved for Decimal Floating-Point extension
   ,1'b0 //      10 K Reserved
   ,1'b0 //      9 J Reserved
   ,1'b1 // <=   8 I RV32I/64I/128I base ISA
   ,1'b0 //      7 H Hypervisor mode implemented
   ,1'b0 //      6 G Additional standard extensions present
   ,1'b0 //      5 F Single-precision floating-point extension
   ,1'b0 //      4 E RV32E base ISA          
   ,1'b0 //      3 D Double-precision floating-point extension
   ,1'b0 //      2 C Compressed extension
   ,1'b0 //      1 B Tentatively reserved for Bit operations extension
   ,1'b0 //      0 A Atomic extension
};

endmodule