`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Modified Date: 2020-02-28
// Design Name:
// Module Name: dug_csr
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module dug_csr(
    input sys_clk,
    
    input [ 11: 0 ] i_csr_addr,
    //input           i_csr_val,
    input i_csr_wen,
    
    output reg o_wr_dcsr_ena,
    output reg o_wr_dpc_ena,
    output reg o_wr_dscrh_ena,

    input rst_n
);



always@( * )   //csr read
case ( i_csr_addr & {12{i_csr_wen}} )
    12'h7b0: o_wr_dcsr_ena  = 1'b1;
    12'h7b1: o_wr_dpc_ena   = 1'b1;
    12'h7b2: o_wr_dscrh_ena = 1'b1;
    default:
    begin
        o_wr_dcsr_ena  = 1'b0;
        o_wr_dpc_ena   = 1'b0;
        o_wr_dscrh_ena = 1'b0;
    end

endcase





endmodule
