`timescale 1ns/100ps
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_iobuf
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module fii_iobuf
#(
    parameter IO_WIDTH = 32
)
(
    input  [ ( IO_WIDTH - 1 ) : 0 ] i_dio_t,
    input  [ ( IO_WIDTH - 1 ) : 0 ] i_dio,
    output [ ( IO_WIDTH - 1 ) : 0 ] o_dio,
    inout  [ ( IO_WIDTH - 1 ) : 0 ] io_dio_p
);


genvar i;
generate

    for ( i = 0; i < IO_WIDTH; i = i + 1 )
    begin: iobuf
        assign o_dio[ i ] = io_dio_p[ i ];
        assign io_dio_p[ i ] = ( i_dio_t[ i ] == 1'b1 ) ? 1'bz : i_dio[ i ];
    end

endgenerate

endmodule
