
`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_rv32i_core
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module fii_dffr # (
    parameter DW = 32
) (
    input [ DW - 1: 0 ] din,
    output reg [ DW - 1: 0 ] q,
    input clk,
    input rst_n
);



always @( posedge clk or negedge rst_n )
if ( !rst_n )
    q <= { DW{ 1'b0 } };
else
    q <= #1 din;

endmodule
