`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_sync
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module fii_sync # (
    parameter DP = 2,
    parameter DW = 32
) (
    input  [ DW - 1: 0 ] din_a,
    output [ DW - 1: 0 ] dout,

    input  clk,
    input  rst_n
);

wire [ DW - 1: 0 ] sync_dat [ DP - 1: 0 ];

genvar i;

generate
    for ( i = 0; i < DP; i = i + 1 )
    begin: sync_gen
        if ( i == 0 )
        begin: i_is_0
            fii_dffr #( DW ) sync_dffr( din_a, sync_dat[ 0 ], clk, rst_n );
        end
        else
        begin: i_is_not_0
            fii_dffr #( DW ) sync_dffr( sync_dat[ i - 1 ], sync_dat[ i ], clk, rst_n );
        end
    end
endgenerate

assign dout = sync_dat[ DP - 1 ];

endmodule
