`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_difflrs
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////



//`define SIM
module fii_dfflr # 
(
    parameter DW = 32
) 
(
    input ld,
    input [ DW - 1: 0 ] din,
    output reg [ DW - 1: 0 ] q,

    input clk,
    input rst_n
);



always @( posedge clk or negedge rst_n )
    if ( !rst_n )
        q <= { DW{ 1'b0 } };
    else if ( ld )
        q <= #1 din;




`ifdef SIM//{ 
//synopsys translate_off
fii_xchecker # 
(
    .DW( 1 )
) 
fii_xchecker
(
    .i ( ld ),
    .clk ( clk )
);
//synopsys translate_on
`endif//}



endmodule
