`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_dfflrs
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module fii_dfflrs # (
  parameter DW = 32
) (
    input                 ld, 
    input        [DW-1:0] din,
    output  reg  [DW-1:0] q,

    input                 clk,
    input                 rst
);



always @(posedge clk or posedge rst)
if (rst)
    q <= {DW{1'b1}};
else if (ld)
    q <= #1 din;




`ifdef SIM//{
//synopsys translate_off
fii_xchecker # (
  .DW(DW)
) fii_xchecker(
  .i_dat(lden),
  .clk  (clk)
);
//synopsys translate_on
`endif//}

    

endmodule