`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_clint_top
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
////////////////////////////////////////////////////////////////////////////////// 

module fii_clint_top (
    input          sys_clk,

    input          l_clk,

    input  [31:0]  i_sft_int_v,
    input  [31:0]  i_timer_l,
    input  [31:0]  i_timer_h,
           
    output [31:0]  o_timer_l,
    output [31:0]  o_timer_h, 
           
    input  [31:0]  i_tcmp_l,
    input  [31:0]  i_tcmp_h,
           
    input  [1:0]   i_timer_valid,
    input  [31:0]  i_tm_ctrl,

    output         o_mtip,
    output         o_msip,

    input          rst_n
);


reg [7:0] rtc_r = 0;
always @ (posedge l_clk)
rtc_r <= rtc_r + 1;

(* ASYNC_REG = "true" *) reg rtc_sys = 0;
always @ (posedge sys_clk )
rtc_sys <= rtc_r[7];


reg [1:0] rtc_toggle = 0;
always @ (posedge sys_clk or negedge rst_n)
if(!rst_n) rtc_toggle <= 0;
else if(i_tm_ctrl[31])
begin
    rtc_toggle <= {rtc_toggle[0], rtc_sys};
end

wire rtcTick = (rtc_toggle == 2'b01) ? 1'b1 :1'b0;



fii_clint u_fii_clint (
    .sys_clk        ( sys_clk ),

    .i_sft_int_v    ( i_sft_int_v ),
    .i_timer_l      ( i_timer_l ),
    .i_timer_h      ( i_timer_h ),
 
    .o_timer_l      ( o_timer_l ),
    .o_timer_h      ( o_timer_h ), 
 
    .i_tcmp_l       ( i_tcmp_l ),
    .i_tcmp_h       ( i_tcmp_h ),
 
    .i_timer_valid  ( i_timer_valid ),
    .i_tm_ctrl      ( i_tm_ctrl ),
 
    .o_mtip         ( o_mtip ),
    .o_msip         ( o_msip ),
    .i_rtcTick      ( rtcTick ),
 
    .rst_n          ( rst_n )
);

endmodule
