`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_irq_clint
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////


module fii_irq_clint
(
    input sys_clk,

    input [ 31: 0 ] i_sft_int_v,
    
    input [ 31: 0 ] i_timer_l,
    input [ 31: 0 ] i_timer_h,

    output [ 31: 0 ] o_timer_l,
    output [ 31: 0 ] o_timer_h,

    input [ 31: 0 ] i_tcmp_l,
    input [ 31: 0 ] i_tcmp_h,

    input [ 1: 0 ] i_timer_valid,
    input [ 31: 0 ] i_tm_ctrl,

    output clint_tmr_irq,
    output clint_sft_irq,

    input l_clk,
    input rst_n
);

fii_clint_top u_fii_clint_top (
    .sys_clk    ( sys_clk ),

    .i_sft_int_v( i_sft_int_v ),
    .i_timer_l  ( i_timer_l ),
    .i_timer_h  ( i_timer_h ),

    .o_timer_l  ( o_timer_l ),
    .o_timer_h  ( o_timer_h ),

    .i_tcmp_l   ( i_tcmp_l ),
    .i_tcmp_h   ( i_tcmp_h ),

    .i_timer_valid( i_timer_valid ),
    .i_tm_ctrl  ( i_tm_ctrl ),

    .l_clk      ( l_clk ),
    .o_mtip     ( clint_tmr_irq ),
    .o_msip     ( clint_sft_irq ),

    .rst_n      ( rst_n )
);


endmodule

