`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: regfile_I
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////
//`include "fii_rv32_def.v"
module regfile_I(
    input  sys_clk,             // ϵͳʱ
    
    input  i_EXE_vld,           // ִenable ź
    
    input  [ 4: 0 ] i_rs1_idx,  // ָеrs1
    input  [ 4: 0 ] i_rs2_idx,  // ָеrs2
    
    output [ 31: 0 ] o_rs1_val, // ָеrs1,Ӧ32ͨüĴѡеļĴֵ
    output [ 31: 0 ] o_rs2_val, // ָеrs2,Ӧ32ͨüĴѡеļĴֵ

    input  i_wb_wen,            // дͨüĴ ź
    input  [ 4: 0 ] i_wb_rd_idx,// ָеrd,
    input  [ 31: 0 ] i_wb_val   // ָеrd,Ӧ32ͨüĴѡеļĴֵ
);

wire [ 31: 0 ] rf_r [ 31: 1 ];
wire [ 31: 1 ] rf_wen;


genvar i;
generate
    for ( i = 1; i < 32; i = i + 1 )
    begin : REG
        assign rf_wen[ i ] = i_EXE_vld & i_wb_wen & ( i_wb_rd_idx == i ) ;
        fii_dffl #( 32 ) rf_dffl ( rf_wen[ i ], i_wb_val, rf_r[ i ], sys_clk );
    end
endgenerate


`ifdef sim
    assign o_rs1_val = ( i_rs1_idx == 0 ) ? 32'b0 :
        ( rf_r[ i_rs1_idx ] == 32'hxxxxxxxx ) ? 32'b0 : rf_r[ i_rs1_idx ];
    assign o_rs2_val = ( i_rs2_idx == 0 ) ? 32'b0 :
       ( rf_r[ i_rs2_idx ] == 32'hxxxxxxxx ) ? 32'b0 : rf_r[ i_rs2_idx ];
`else
    assign o_rs1_val = ( i_rs1_idx == 0 ) ? 32'b0 : rf_r[ i_rs1_idx ];
    assign o_rs2_val = ( i_rs2_idx == 0 ) ? 32'b0 : rf_r[ i_rs2_idx ];
`endif



endmodule
