`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Modified Date: 2020-02-28
// Design Name:
// Module Name: fii_irq_sync
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////

module fii_irq_sync
(
    input  clk,

    input  ext_irq_a,
    input  sft_irq_a,
    input  tmr_irq_a,
    input  dbg_irq_a,

    output ext_irq_r,
    output sft_irq_r,
    output tmr_irq_r,
    output dbg_irq_r,

    input  rst_n
);



fii_sync # (
    .DP( 1 ),
    .DW( 1 )
) u_dbg_irq_sync(
    .din_a  ( dbg_irq_a ),
    .dout   ( dbg_irq_r ),
    .clk    ( clk ),
    .rst_n  ( rst_n )
);


fii_sync # (
    .DP( 1 ),
    .DW( 1 )
) u_ext_irq_sync(
    .din_a  ( ext_irq_a ),
    .dout   ( ext_irq_r ),
    .clk    ( clk ),
    .rst_n  ( rst_n )
);

fii_sync # (
    .DP( 1 ),
    .DW( 1 )
) u_sft_irq_sync(
    .din_a  ( sft_irq_a ),
    .dout   ( sft_irq_r ),
    .clk    ( clk ),
    .rst_n  ( rst_n )
);

fii_sync # (
    .DP( 1 ),
    .DW( 1 )
) u_tmr_irq_sync(
    .din_a  ( tmr_irq_a ),
    .dout   ( tmr_irq_r ),
    .clk    ( clk ),
    .rst_n  ( rst_n )
);




endmodule
