`timescale 1ns / 1ps 
//////////////////////////////////////////////////////////////////////////////////
// Company:     Fraser Innavotion Inc
// Engineer:    Qianqi(Tim) Zhuang & William Gou
//
// Create Date: 09/25/2018 09:28:18 AM
// Design Name:
// Module Name: fii_timer_lsu
// Project Name: RISC-V SOC RTL
// Target Devices: FII-PE7030, FII-PRX100T, FII-BM7100, FII-PRA040, FII-PRA006
// Tool Versions: vivado 18.1/18.2
// Description:
//
// Dependencies:
// this is a simple version of risc-v integer version,aim to show up basic concept of RTL
// Revision:1.0
// Revision 0.01 - File Created
// Additional Comments:
//
//////////////////////////////////////////////////////////////////////////////////
module fii_timer_lsu
(
    input clk,

    input [ 31: 0 ] i_sft_timer_din,
    input i_tmr_sft_we,

//  register group
    input i_tm_ctrl_cs,
    output reg [ 31: 0 ] o_tm_ctrl,

    input i_sft_cs,
    output reg [ 31: 0 ] o_sft_int_v,

    input i_tcs0,
    output reg [ 31: 0 ] o_timer_l,

    input i_tcs1,
    output reg [ 31: 0 ] o_timer_h,

    input i_tcmp_cs0,
    output reg [ 31: 0 ] o_tcmp_l,

    input i_tcmp_cs1,
    output reg [ 31: 0 ] o_tcmp_h,

    output reg [ 1: 0 ] o_timer_valid,

    input rst_n
);

always@( posedge clk or negedge rst_n )
if ( !rst_n )
begin
    o_tm_ctrl <= 0;
    o_sft_int_v <= 0;
    o_timer_l <= 0;
    o_timer_h <= 0;
    o_tcmp_l <= 0;
    o_tcmp_h <= 16'h8000;
    o_timer_valid <= 0;
end
else
begin
    o_timer_valid <= 0;

    if ( i_tmr_sft_we )
    begin
        if ( i_sft_cs )
            o_sft_int_v <= { 31'b0, i_sft_timer_din[ 0 ] };

        if ( i_tcs0 )
        begin
            o_timer_l <= i_sft_timer_din;
            o_timer_valid[ 0 ] <= 1'b1;
        end

        if ( i_tcs1 )
        begin
            o_timer_h <= i_sft_timer_din;
            o_timer_valid[ 1 ] <= 1'b1;
        end

        if ( i_tcmp_cs0 )
            o_tcmp_l <= i_sft_timer_din;

        if ( i_tcmp_cs1 )
            o_tcmp_h <= i_sft_timer_din;

        if ( i_tm_ctrl_cs )
            o_tm_ctrl <= i_sft_timer_din;
    end
end


endmodule
